
;; Representation: a List is a Scheme list wrapped in a list struct

(define-struct list (content))


;; Creators

(define (L:empty) 
  (make-list '()))

(define (L:singleton a) 
  (make-list (cons a '())))

(define (L:merge L M) 
  (define (->schemelist L)
    (if (L:isEmpty L)
	'()
	(cons (L:first L) (->schemelist (L:rest L)))))
  (define (app L1 L2)
    (if (L:isEmpty L1)
	(->schemelist L2)
	(cons (L:first L1)
	      (app (L:rest L1) L2))))
  (make-list (app L M)))

(define (L:merge L M) 
  (define (app l1 l2)
    (if (null? l1)
        l2
        (cons (first l1)
              (app (rest l1) l2))))
  (make-list (app (list-content L) 
                  (list-content M))))


;; Operations

(define (L:isEmpty L)
  (let ((l (list-content L)))
    (null? l)))

(define (L:first L)
  (let ((l (list-content L)))
    (if (null? l)
	(error "(L:first L): L is empty")
	(car l))))

(define (L:rest L)
  (let ((l (list-content L)))
    (if (null? l)
	(error "(L:rest L): L is empty")
	(make-list (cdr l)))))

(define (L:length L)
  (let ((l (list-content L)))
    (length l)))

(define (L:isEqual L M)
  (or (and (L:isEmpty L) (L:isEmpty M))
      (and (not (L:isEmpty L)) (not (L:isEmpty M))
	   (= (L:first L) (L:first M))
	   (L:isEqual (L:rest L) (L:rest M)))))
