
(define-syntax (check-equation syntax-object)
  (syntax-case syntax-object ()
    ((_ expr result)
     #'(if (= expr result)
	   #t
	   (error "Test failed -- " (quote (check-equation expr result))
                  " -- expected " result " got " expr)))))
	   

;; (define (equal-angles ...


(let ((x (- (random 1000) 500))
      (y (- (random 1000) 500))
      (r (random 1000))
      (t (* 2 pi (random))))
  (check-equation (xCoord (cartesian x y)) 
		  x)
  (check-equation (xCoord (polar r t))
		  (* r (cos t)))
  (check-equation (yCoord (cartesian x y)) 
		  y)
  (check-equation (yCoord (polar r t))
		  (* r (sin t)))
  (check-equation (angle-with-x-axis (cartesian x y)) 
		  (atan y x))
  (check-equation (angle-with-x-axis (polar r t))
		  t)
  (check-equation (distance-from-origin (cartesian x y))
		  (sqrt (+ (* x x) (* y y ))))
  (check-equation (distance-from-origin (polar r t))
		  r))
